package cs108;

import java.util.ArrayList;
import java.util.List;

import static java.lang.Math.max;
import static java.util.Collections.unmodifiableList;

final class Above implements TextImage {
    private final TextImage top, bottom;

    public Above(TextImage top, TextImage bottom) {
        this.top = top;
        this.bottom = bottom;
    }

    @Override
    public int width() {
        return max(top.width(), bottom.width());
    }

    @Override
    public int height() {
        return top.height() + bottom.height();
    }

    @Override
    public List<String> drawing() {
        List<String> d = new ArrayList<>(height());
        int w = width();
        for (String l: top.drawing())
            d.add(l + Strings.nCopies(w - top.width(), ' '));
        for (String l: bottom.drawing())
            d.add(l + Strings.nCopies(w - bottom.width(), ' '));
        return unmodifiableList(d);
    }
}
