package cs108;

import java.util.ArrayList;
import java.util.List;

import static java.util.Collections.unmodifiableList;

final class FlippedHorizontally implements TextImage {
    private final TextImage toFlip;

    public FlippedHorizontally(TextImage toFlip) {
        this.toFlip = toFlip;
    }

    @Override
    public int width() {
        return toFlip.width();
    }

    @Override
    public int height() {
        return toFlip.height();
    }

    @Override
    public List<String> drawing() {
        List<String> o = toFlip.drawing();
        List<String> f = new ArrayList<>(o.size());
        for (String l: o)
            f.add(Strings.reverse(l));
        return unmodifiableList(f);
    }
}
