package cs108;

import java.util.ArrayList;
import java.util.List;

final class Transposed implements TextImage {
    private final TextImage toTranspose;

    public Transposed(TextImage toTranspose) {
        this.toTranspose = toTranspose;
    }

    @Override
    public int width() {
        return toTranspose.height();
    }

    @Override
    public int height() {
        return toTranspose.width();
    }

    @Override
    public List<String> drawing() {
        List<String> transposed = new ArrayList<>(height());
        List<String> linesToTranspose = toTranspose.drawing();
        for (int c = 0; c < height(); c += 1) {
            StringBuilder b = new StringBuilder();
            for (String row : linesToTranspose)
                b.append(row.charAt(c));
            transposed.add(b.toString());
        }
        return transposed;
    }
}
